package me.Demon.BlockWars.Game;

import me.Demon.BlockWars.Main;
import me.Demon.BlockWars.Util.RandomUtil;
import org.bukkit.Bukkit;
import org.bukkit.Location;
import org.bukkit.Particle;
import org.bukkit.entity.*;
import org.bukkit.potion.PotionEffect;
import org.bukkit.potion.PotionEffectType;
import org.bukkit.scheduler.BukkitRunnable;
import org.bukkit.scheduler.BukkitTask;
import org.bukkit.util.Vector;

public class EffectEntity {

    public static GameData game = Main.gameData;
    public static void effect_Rotate_360(Player zhubo) {
        if(!game.isStarted()){
            return;
        }
        BukkitTask task = new BukkitRunnable() {
            double yaw = 0;
            long startTime = System.currentTimeMillis();
            @Override
            public void run() {
                yaw += 1.5; // 每次旋转2度
                if (yaw >= 360) {
                    yaw -= 360;
                }
                Vector direction = zhubo.getLocation().getDirection();
                double angle = Math.toRadians(yaw);
                double newX = direction.getX() * Math.cos(angle) - direction.getZ() * Math.sin(angle);
                double newZ = direction.getX() * Math.sin(angle) + direction.getZ() * Math.cos(angle);
                direction.setX(newX);
                direction.setZ(newZ);
                zhubo.teleport(zhubo.getLocation().setDirection(direction));
                long currentTime = System.currentTimeMillis();
                if (currentTime - startTime >= 4000) {
                    cancel();
                }
            }
        }.runTaskTimer(Main.plugin, 0L, 2L);
        game.addTasks(task);
        zhubo.addPotionEffect(new PotionEffect(PotionEffectType.SPEED, 20 * 4, 5,false,false));
    }

    public static void effect_spawn_pig(Player player, String userName, int amount) {
        if (!game.isStarted()) {
            return;
        }
        for (int i = 0; i < amount; i++) {
            Bukkit.getScheduler().runTaskLater(Main.plugin, () -> {
                Location loc = player.getLocation();
                loc.getWorld().spawnParticle(Particle.LAVA, loc, 5, 1, 1, 1, 0.085);
                Vector launchVector = new Vector(RandomUtil.getRandomDouble(-0.5, 0.5, 1), RandomUtil.getRandomDouble(0, 0.5, 1), RandomUtil.getRandomDouble(-0.5, 0.5, 1));
                Pig pig = (Pig) loc.getWorld().spawnEntity(loc, EntityType.PIG);
                pig.setHealth(1);
                pig.setCustomName("§b"+userName);
                pig.setCustomNameVisible(true);
                pig.setVelocity(launchVector);
                player.playSound(player.getLocation(), "fangpi", 1.0F, 1.0F);
            }, (long) i * 5);
        }
    }

    public static void effect_spawn_Zombie(Player player,String userName,int amount) {
        if (!game.isStarted()) {
            return;
        }
        Region region = game.getRegion();
        for (int i = 0; i < amount;i++) {
            Location location = RandomUtil.getRandomLocation(player,region.getWorld(), region.getMin().getX() + 1, region.getMax().getX() -1, region.getMax().getY()+3, region.getMax().getY()+6, region.getMin().getZ() + 1, region.getMax().getZ() - 1);
            Vector launchVector = new Vector(RandomUtil.getRandomDouble(-0.5, 0.5, 1), RandomUtil.getRandomDouble(-1, 0, 1), RandomUtil.getRandomDouble(-0.5, 0.5, 1));
            location.getWorld().spawnParticle(Particle.LAVA, location, 5, 1, 1, 1, 0.085);
            Zombie entity = (Zombie) location.getWorld().spawnEntity(location, EntityType.ZOMBIE);
            entity.setBaby(false);
            entity.setMaxHealth(2);
            entity.setCustomName("§c" + userName);
            entity.setCustomNameVisible(true);
            entity.setVelocity(launchVector);
            player.playSound(player.getLocation(), "fangpi", 1.0F, 1.0F);
        }
    }

    public static void effect_spawn_IronGolem(Player player,String userName,int amount) {
        if (!game.isStarted()) {
            return;
        }
        Region region = game.getRegion();
        for (int i = 0; i < amount;i++) {
            Location location = RandomUtil.getRandomLocation(player,region.getWorld(), region.getMin().getX() + 1, region.getMax().getX() -1, region.getMax().getY()+3, region.getMax().getY()+6, region.getMin().getZ() + 1, region.getMax().getZ() - 1);
            Vector launchVector = new Vector(RandomUtil.getRandomDouble(-0.5, 0.5, 1), RandomUtil.getRandomDouble(-1, -0.5, 1), RandomUtil.getRandomDouble(-0.5, 0.5, 1));
            location.getWorld().spawnParticle(Particle.LAVA, location, 5, 1, 1, 1, 0.085);
            IronGolem entity = (IronGolem) location.getWorld().spawnEntity(location, EntityType.IRON_GOLEM);
            entity.setMaxHealth(10);
            entity.setCustomName("§a" + userName);
            entity.setCustomNameVisible(true);
            entity.setVelocity(launchVector);
            player.playSound(player.getLocation(), "fangpi", 1.0F, 1.0F);
        }
    }
}
