package me.Demon.BlockWars.Game;

import cn.hamster3.cdapi.CDTimeAPI;
import me.Demon.BlockWars.Main;
import me.Demon.BlockWars.Util.RandomUtil;
import org.bukkit.Bukkit;
import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.block.Block;
import org.bukkit.entity.FallingBlock;
import org.bukkit.entity.Player;
import org.bukkit.scheduler.BukkitRunnable;
import org.bukkit.util.Vector;

import java.util.*;
import java.util.concurrent.atomic.AtomicBoolean;

public abstract class EffectTime {

    public static GameData game = Main.gameData;

    public static void effect_moveBlock(Player player) {
        if (!game.isStarted()) {
            return;
        }
        UUID uuid = player.getUniqueId();
        String cd_key = "move_remove_block";
        if(CDTimeAPI.getCD(uuid,cd_key) >= 1){
            long move_time = CDTimeAPI.getCD(uuid,cd_key) + (1000 * 15);
            CDTimeAPI.setPlayerCD(uuid,cd_key,move_time);
        }else{
            CDTimeAPI.setPlayerCD(uuid,cd_key,1000 * 15);
        }
        Vector launchVector = new Vector(0, 1, 0);
        player.setVelocity(launchVector);
        player.playSound(player.getLocation(),"niganma",1,1);
    }

    public static Set<Block> getRandomUpBlocks(Region region, int amount) {
        List<Block> blocks = new ArrayList<>();
        for (int x = (int) Math.floor(region.getMin().getX()); x <= region.getMax().getX(); x++) {
            for (int z = (int) Math.floor(region.getMin().getZ()); z <= region.getMax().getZ(); z++) {
                t:
                for (int y = (int) Math.floor(region.getMax().getY()); y >= region.getMin().getY(); y--) {
                    Block block = region.getWorld().getBlockAt(x, y, z);
                    if (!block.getType().equals(Material.AIR)) {
                        blocks.add(block);
                        break;
                    }
                }
            }
        }
        Set<Block> blocks1 = new HashSet<>();
        for (int i = 0; i < amount; i++) {
            int k = RandomUtil.getRandomInt(0, blocks.size() - 1);
            Block block = blocks.remove(k);
            blocks1.add(block);
        }
        return blocks1;
    }

    public static void effectBlackHoleBlock(Player zhubo){
        Region region = game.getRegion();
        Location location = zhubo.getLocation();
        List<FallingBlock> fallingBlocks = new ArrayList<>();
        AtomicBoolean stop = new AtomicBoolean(false);
        new BukkitRunnable() {
            private int i = 0;
            @Override
            public void run() {
                if (i >= 5) {
                    Bukkit.getScheduler().runTaskLater(Main.plugin, ()-> {
                        stop.set(true);
                        fallingBlocks.forEach(fallingBlock -> fallingBlock.setGravity(true));
                        location.getWorld().createExplosion(location, 3.0F, false, false);
                    }, 20L);
                    cancel();
                    return;
                }
                Set<Block> blocks = getRandomUpBlocks(region, 100);
                for (Block block : blocks) {
                    FallingBlock fallingBlock = region.getWorld().spawnFallingBlock(block.getLocation().add(0.5, 0, 0.5), block.getBlockData());
                    fallingBlock.setDropItem(false);
                    fallingBlock.setHurtEntities(false);
                    fallingBlock.setGravity(false);
                    block.setType(Material.AIR);
                    fallingBlocks.add(fallingBlock);
                }
                i++;
            }
        }.runTaskTimer(Main.plugin, 0L, 10L);
        new BukkitRunnable() {
            private Set<UUID> uuids = new HashSet<>();
            @Override
            public void run() {
                if (stop.get()) {
                    cancel();
                    return;
                }
                Iterator<FallingBlock> iterator = fallingBlocks.iterator();
                while (iterator.hasNext()) {
                    FallingBlock fallingBlock = iterator.next();
                    Vector vector = fallingBlock.getLocation().toVector();
                    Vector vector1 = location.toVector();
                    Vector vector2 = vector1.subtract(vector);
                    vector2.normalize();
                    vector2.multiply(0.65);
                    fallingBlock.setVelocity(vector2);
                    if (!uuids.contains(fallingBlock.getUniqueId())) {
                        if (RandomUtil.random(0.5)) {
                            uuids.add(fallingBlock.getUniqueId());
                        } else {
                            fallingBlock.remove();
                            iterator.remove();
                        }
                    }
                }
            }
        }.runTaskTimer(Main.plugin, 0L, 1L);
    }

    public static void effectJumpSkyTnt(Player zhubo,long seconds){
        if(!game.isStarted()){return;}
        UUID uuid = zhubo.getUniqueId();
        String cdKey = "skyTnt";
        long timeMilli = CDTimeAPI.getCD(uuid,cdKey);
        if(timeMilli >= 1){
            CDTimeAPI.setPlayerCD(uuid,cdKey,timeMilli + (1000*seconds));
        }else{
            CDTimeAPI.setPlayerCD(uuid,cdKey,1000 * seconds);
        }
        Bukkit.getScheduler().runTaskLater(Main.plugin, () -> {
            Vector launchVector = new Vector(0, 1, 0);
            zhubo.setVelocity(launchVector);
        },2L);
    }
}
