package me.Demon.BlockWars.Game;

import me.Demon.BlockWars.Game.GameData;
import me.Demon.BlockWars.Main;
import me.Demon.BlockWars.Util.RandomUtil;
import org.bukkit.*;
import org.bukkit.entity.EntityType;
import org.bukkit.entity.Player;
import org.bukkit.entity.TNTPrimed;
import org.bukkit.scheduler.BukkitRunnable;
import org.bukkit.scheduler.BukkitTask;
import org.bukkit.util.Vector;

public abstract class EffectTnt {

    public static GameData game = Main.gameData;
    public static void effect_jump_tnt(Player zhubo) {
        zhubo.setVelocity(zhubo.getLocation().getDirection().multiply(0.5).setY(1.0));
        zhubo.playEffect(zhubo.getLocation(), Effect.MOBSPAWNER_FLAMES, 10);
        zhubo.playSound(zhubo.getLocation(), Sound.ENTITY_BAT_TAKEOFF, 1.0F, 1.0F);
        BukkitTask task = new BukkitRunnable() {
            private int i= 0;
            @Override
            public void run() {
                if(i >= 6){cancel();}
                Location location = zhubo.getLocation();
                TNTPrimed tntPrimed = (TNTPrimed) location.getWorld().spawnEntity(location.clone().add(0,-0.5,0), EntityType.PRIMED_TNT);
                tntPrimed.setFuseTicks(5);
                tntPrimed.setYield(0.0F);
                location.getWorld().playSound(location, Sound.ENTITY_CREEPER_PRIMED, 1.0f, 1.0f);
                i++;
            }
        }.runTaskTimer(Main.plugin, 2L,1L);
        game.addTasks(task);
    }

    public static void spawnTNT(Location location, int fuseTick,float Yield) {
        Location newTnt_loc = location.add(0,RandomUtil.getRandomInt(-2,2),0);
        TNTPrimed tntPrimed = (TNTPrimed) game.getRegion().getWorld().spawnEntity(newTnt_loc, EntityType.PRIMED_TNT);
        tntPrimed.setFuseTicks(fuseTick);
        tntPrimed.setYield(Yield);
        if(fuseTick == 35) {
            if (RandomUtil.getRandomInt(1, 100) >= 70) {
                tntPrimed.setVelocity(new Vector(RandomUtil.getRandomDouble(-1, 1, 2), RandomUtil.getRandomDouble(0, 1, 2), RandomUtil.getRandomDouble(-1, 1, 2)));
            }
        }
        location.getWorld().playSound(newTnt_loc, Sound.ENTITY_CREEPER_PRIMED, 1.0f, 1.0f);
    }

    public static void callPlayerTntDrop(Player player,int amount) {
        boolean check_loc = false;
        if (game.getRegion().isRegionTNTAppearance(player.getLocation())) {
            check_loc = true;
        }
        if(amount >= 1000){
            if (check_loc) {
                for (int i = 0; i < 30; i++) {
                    Bukkit.getScheduler().runTaskLater(Main.plugin, () -> {
                        for (int x = 0; x < 15; x++) {
                            Vector launchVector = new Vector(RandomUtil.getRandomDouble(-1, 1, 1), RandomUtil.getRandomDouble(-2, 0.2, 1), RandomUtil.getRandomDouble(-1, 1, 1));
                            Location location = player.getLocation().clone();
                            TNTPrimed tntPrimed = (TNTPrimed) player.getWorld().spawnEntity(location, EntityType.PRIMED_TNT);
                            tntPrimed.setFuseTicks(20);
                            tntPrimed.setYield(2.5F);
                            tntPrimed.setVelocity(launchVector);
                            location.getWorld().playSound(location, Sound.ENTITY_CREEPER_PRIMED, 1.0f, 1.0f);
                        }
                        player.playSound(player.getLocation(), "jujueno", 1.0F, 1.0F);
                    }, (long) i * 5);
                }
            }else {
                callForBombDrops(player, amount);
            }
        } else {
            if (check_loc) {
                for (int i = 0; i < amount; i++) {
                    Bukkit.getScheduler().runTaskLater(Main.plugin, () -> {
                        Location location = player.getLocation().clone();
                        TNTPrimed tntPrimed = (TNTPrimed) player.getWorld().spawnEntity(location.add(0, 0.2, 0), EntityType.PRIMED_TNT);
                        tntPrimed.setFuseTicks(40);
                        tntPrimed.setYield(2.0F);
                        tntPrimed.setVelocity(location.getDirection().multiply(0.6D).setY(-0.05));
                        location.getWorld().playSound(location, Sound.ENTITY_CREEPER_PRIMED, 1.0f, 1.0f);
                    }, (long) i * 2);
                }
            } else {
                callForBombDrops(player, amount);
            }
        }
    }
    public static void callForBombDrops(Player zhubo, int amount) {
        if (!game.isStarted()) {return;}
        Region region = game.getRegion();
        int y = (int) (Math.round(region.getMax().getY()) + RandomUtil.getRandomInt(1,10));
        if(amount <= 1){
            Location location = RandomUtil.getRandomLocation(zhubo,region.getWorld(), region.getMin().getX() + 1, region.getMax().getX() -1, y, y, region.getMin().getZ() + 1, region.getMax().getZ() - 1);
            spawnTNT(location, 60,2.5F);
        } else if(amount >= 5000) {
            // 获取掉落次数
            int max_kongtou = 100;
            // 获取每次掉落数量
            int kongtou_tnt = (int) (amount / max_kongtou * 0.7);
            for (int k = 0; k < max_kongtou; k++) {
                BukkitTask task = Bukkit.getScheduler().runTaskLater(Main.plugin, ()->{
                    for (int i = 0; i < kongtou_tnt; i++) {
                        Location location = RandomUtil.getRandomLocation(zhubo,region.getWorld(), region.getMin().getX() + 1, region.getMax().getX() -1, y, y, region.getMin().getZ() + 1, region.getMax().getZ() - 1);
                        spawnTNT(location,  RandomUtil.getRandomInt(30,70),2.5F);
                        location.getWorld().spawnParticle(Particle.FIREWORKS_SPARK, location, RandomUtil.getRandomInt(1,10), 1.1, 1.1, 1.1, 0.35);
                    }
                }, (long) k * 8);
                game.addTasks(task);
            }
        } else if(amount >= 200) {
            // 获取掉落次数
            int max_kongtou = 8 + (amount / 100);
            // 获取每次掉落数量
            int kongtou_tnt = (int) (amount / max_kongtou * 0.7);
            for (int k = 0; k < max_kongtou; k++) {
                BukkitTask task = Bukkit.getScheduler().runTaskLater(Main.plugin, ()->{
                    for (int i = 0; i < kongtou_tnt; i++) {
                        Location location = RandomUtil.getRandomLocation(zhubo,region.getWorld(), region.getMin().getX() + 1, region.getMax().getX() -1, y, y, region.getMin().getZ() + 1, region.getMax().getZ() - 1);
                        spawnTNT(location,  RandomUtil.getRandomInt(30,70),2.5F);
                        location.getWorld().spawnParticle(Particle.FIREWORKS_SPARK, location, RandomUtil.getRandomInt(1,10), 1.1, 1.1, 1.1, 0.35);
                    }
                }, (long) k * 8);
                game.addTasks(task);
            }
        }else if(amount >= 150) {
            // 获取掉落次数
            int max_kongtou = 8;
            // 获取每次掉落数量
            int kongtou_tnt = 13;
            for (int k = 0; k < max_kongtou; k++) {
                BukkitTask task = Bukkit.getScheduler().runTaskLater(Main.plugin, ()->{
                    for (int i = 0; i < kongtou_tnt; i++) {
                        Location location = RandomUtil.getRandomLocation(zhubo,region.getWorld(), region.getMin().getX() + 1, region.getMax().getX() -1, y, y, region.getMin().getZ() + 1, region.getMax().getZ() - 1);
                        spawnTNT(location, RandomUtil.getRandomInt(30,70),2.5F);
                        location.getWorld().spawnParticle(Particle.FIREWORKS_SPARK, location, RandomUtil.getRandomInt(1,10), 1.1, 1.1, 1.1, 0.35);
                    }
                }, (long) k * 8);
                game.addTasks(task);
            }
        }else if(amount >= 100) {
            // 获取掉落次数
            int max_kongtou = 8;
            // 获取每次掉落数量
            int kongtou_tnt = 11;
            for (int k = 0; k < max_kongtou; k++) {
                BukkitTask task = Bukkit.getScheduler().runTaskLater(Main.plugin, ()->{
                    for (int i = 0; i < kongtou_tnt; i++) {
                        Location location = RandomUtil.getRandomLocation(zhubo,region.getWorld(), region.getMin().getX() + 1, region.getMax().getX() -1, y, y, region.getMin().getZ() + 1, region.getMax().getZ() - 1);
                        spawnTNT(location,  RandomUtil.getRandomInt(30,70),2.5F);
                        location.getWorld().spawnParticle(Particle.FIREWORKS_SPARK, location, RandomUtil.getRandomInt(1,10), 1.1, 1.1, 1.1, 0.35);
                    }
                }, (long) k * 8);
                game.addTasks(task);
            }
        }else if(amount >= 90) {
            // 获取掉落次数
            int max_kongtou = 6;
            // 获取每次掉落数量
            int kongtou_tnt = 12;
            for (int k = 0; k < max_kongtou; k++) {
                BukkitTask task = Bukkit.getScheduler().runTaskLater(Main.plugin, ()->{
                    for (int i = 0; i < kongtou_tnt; i++) {
                        Location location = RandomUtil.getRandomLocation(zhubo,region.getWorld(), region.getMin().getX() + 1, region.getMax().getX() -1, y, y, region.getMin().getZ() + 1, region.getMax().getZ() - 1);
                        spawnTNT(location, RandomUtil.getRandomInt(30,70),2.5F);
                        location.getWorld().spawnParticle(Particle.FIREWORKS_SPARK, location, RandomUtil.getRandomInt(1,10), 1.1, 1.1, 1.1, 0.35);
                    }
                }, (long) k * 8);
                game.addTasks(task);
            }
        }else if(amount >= 50) {
            // 获取掉落次数
            int max_kongtou = 5;
            // 获取每次掉落数量
            int kongtou_tnt = 8;
            for (int k = 0; k < max_kongtou; k++) {
                BukkitTask task = Bukkit.getScheduler().runTaskLater(Main.plugin, ()->{
                    for (int i = 0; i < kongtou_tnt; i++) {
                        Location location = RandomUtil.getRandomLocation(zhubo,region.getWorld(), region.getMin().getX() + 1, region.getMax().getX() -1, y, y, region.getMin().getZ() + 1, region.getMax().getZ() - 1);
                        spawnTNT(location, RandomUtil.getRandomInt(30,70),2.5F);
                        location.getWorld().spawnParticle(Particle.FIREWORKS_SPARK, location, RandomUtil.getRandomInt(1,10), 1.1, 1.1, 1.1, 0.35);
                    }
                }, (long) k * 8);
                game.addTasks(task);
            }
        }else if(amount >= 20) {
            // 获取掉落次数
            int max_kongtou = 4;
            // 获取每次掉落数量
            int kongtou_tnt = 4;
            for (int k = 0; k < max_kongtou; k++) {
                BukkitTask task = Bukkit.getScheduler().runTaskLater(Main.plugin, ()->{
                    for (int i = 0; i < kongtou_tnt; i++) {
                        Location location = RandomUtil.getRandomLocation(zhubo,region.getWorld(), region.getMin().getX() + 1, region.getMax().getX() -1, y, y, region.getMin().getZ() + 1, region.getMax().getZ() - 1);
                        spawnTNT(location,RandomUtil.getRandomInt(30,70),2.5F);
                        location.getWorld().spawnParticle(Particle.FIREWORKS_SPARK, location, RandomUtil.getRandomInt(1,10), 1.1, 1.1, 1.1, 0.35);
                    }
                }, (long) k * 8);
                game.addTasks(task);
            }
        } else if(amount >= 10) {
            // 获取掉落次数
            int max_kongtou = 3;
            // 获取每次掉落数量
            int kongtou_tnt = 3;
            for (int k = 0; k < max_kongtou; k++) {
                BukkitTask task = Bukkit.getScheduler().runTaskLater(Main.plugin, ()->{
                    for (int i = 0; i < kongtou_tnt; i++) {
                        Location location = RandomUtil.getRandomLocation(zhubo,region.getWorld(), region.getMin().getX() + 1, region.getMax().getX() -1, y, y, region.getMin().getZ() + 1, region.getMax().getZ() - 1);
                        spawnTNT(location,RandomUtil.getRandomInt(30,70),2.5F);
                        location.getWorld().spawnParticle(Particle.FIREWORKS_SPARK, location, RandomUtil.getRandomInt(1,10), 1.1, 1.1, 1.1, 0.35);
                    }
                }, (long) k * 8);
                game.addTasks(task);
            }
        } else {
            for (int i = 0; i < amount; i++) {
                long delay = 1 + (i * 3L);
                BukkitTask task = new BukkitRunnable() {
                    @Override
                    public void run() {
                        Location location = RandomUtil.getRandomLocation(zhubo,region.getWorld(), region.getMin().getX() + 1, region.getMax().getX() - 1, y, y, region.getMin().getZ() + 1, region.getMax().getZ() - 1);
                        spawnTNT(location,RandomUtil.getRandomInt(30,70), 2.5F);
                        location.getWorld().spawnParticle(Particle.SMOKE_NORMAL, location, 10, 0.85, 0.85, 0.85, 0.02);
                    }
                }.runTaskLater(Main.plugin, delay);
                game.addTasks(task);
            }
        }
    }
}
