package me.Demon.BlockWars;

import me.Demon.BlockWars.Data.RepairGiftGui;
import me.Demon.BlockWars.Game.GameData;
import me.Demon.BlockWars.Listener.*;
import me.Demon.BlockWars.LiveEvent.GiftEventHandler;
import me.Demon.BlockWars.LiveEvent.GiftListener;
import me.Demon.BlockWars.LiveEvent.LikeListener;
import me.Demon.BlockWars.Manager.MinerOperate;
import me.Demon.BlockWars.Util.ComputeBlock;
import me.Demon.BlockWars.Util.ConfigYml;
import me.Demon.BlockWars.Util.GameUtil;
import me.Demon.BlockWars.Util.RandomUtil;
import org.bukkit.Bukkit;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.configuration.file.YamlConfiguration;
import org.bukkit.entity.Player;
import org.bukkit.plugin.java.JavaPlugin;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

public class Main extends JavaPlugin {

    public static boolean Debug = false;
    public static Main plugin;
    public static GameData gameData;
    public static ConfigYml configYml;
    public static FileConfiguration giftYml;
    @Override
    public void onEnable() {
        plugin = this;
        File file = new File("./plugins/游戏设置","礼物设置.yml");
        giftYml = YamlConfiguration.loadConfiguration(file);
        saveDefaultConfig();
        configYml = new ConfigYml();
        gameData = new GameData();
        getServer().getPluginManager().registerEvents(new JoinEvent(),this);
        getServer().getPluginManager().registerEvents(new GamePotect(),this);
        getServer().getPluginManager().registerEvents(new GameListener(),this);
        getServer().getPluginManager().registerEvents(new GameEffect(),this);
        getServer().getPluginManager().registerEvents(new GiftListener(),this);
        getServer().getPluginManager().registerEvents(new LikeListener(),this);
        getServer().getPluginManager().registerEvents(new RepairGiftGui(),this);
    }

    @Override
    public boolean onCommand(CommandSender sender, Command command, String Command, String[] args) {
        if (Command.equalsIgnoreCase("livegift")) {
            RepairGiftGui.OpenGui((Player) sender);
            return true;
        }
        if (Command.equalsIgnoreCase("game") || Command.equalsIgnoreCase("bw")) {
            if (args.length == 0) {
                sender.sendMessage("");
                sender.sendMessage("§e------ ====== §6TNT炸弹填充 §e====== ------");
                sender.sendMessage("§2/"+Command+" add §e[数量] §f- §2增加成功次数");
                sender.sendMessage("§2/"+Command+" take §e[数量] §f- §2减少成功次数");
                sender.sendMessage("§e------ ====== §6TNT炸弹填充 §e====== ------");
                sender.sendMessage("");
                return true;
            }
            if(args.length == 1 && args[0].equalsIgnoreCase("add")){
                if (!Main.gameData.isStarted()) {
                    return true;
                }
                Main.gameData.effect_addComplete(1);
            }
            if(args.length == 1 && args[0].equalsIgnoreCase("take")){
                if (!Main.gameData.isStarted()) {
                    return true;
                }
                Main.gameData.effect_takeComplete(1);
            }
            if(args.length == 2 && args[0].equalsIgnoreCase("add")){
                if (!Main.gameData.isStarted()) {
                    return true;
                }
                int amount = Integer.parseInt(args[1]);
                Main.gameData.effect_addComplete(amount);
                return true;
            }
            if(args.length == 2 && args[0].equalsIgnoreCase("take")) {
                if (!Main.gameData.isStarted()) {
                    return true;
                }
                int amount = Integer.parseInt(args[1]);
                Main.gameData.effect_takeComplete(amount);
                return true;
            }
            if(args[0].equalsIgnoreCase("updata")){
                gameData.setCompleteBlockGoal(ComputeBlock.getCompleteBlockGoal(Main.gameData.getRegion()));
            }
            if(args.length == 2 && args[0].equalsIgnoreCase("sendevent")){
                List<Player> players = new ArrayList<>(Bukkit.getOnlinePlayers());
                Player player = players.get(0);
                if(sender instanceof Player){
                    player = (Player) sender;
                }
                String eventName = args[1];
                String userName = "观众"+ RandomUtil.getRandomInt(0,10);
                String title = "§c" + eventName;
                String subtitle = "§9" + GameUtil.HideName(userName);
                player.sendTitle(title, subtitle,10, 30, 10);
                GiftEventHandler.SendHandLer(player, userName, eventName);
                return true;
            }
        }
        return false;
    }
}
