package me.Demon.BlockWars.Util;

import com.sk89q.worldedit.EditSession;
import com.sk89q.worldedit.WorldEdit;
import com.sk89q.worldedit.bukkit.BukkitAdapter;
import com.sk89q.worldedit.extent.clipboard.Clipboard;
import com.sk89q.worldedit.extent.clipboard.io.ClipboardFormats;
import com.sk89q.worldedit.math.BlockVector3;
import com.yaohun.RandomBox.api.RBoxAPI;
import com.yaohun.bwaddon.api.ExtendAPI;
import me.Demon.BlockWars.Main;
import org.bukkit.*;
import org.bukkit.block.Block;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Entity;
import org.bukkit.entity.Pig;
import org.bukkit.entity.Player;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemStack;

import java.io.File;

public class GameUtil {

    public static boolean AntiGiftEvent = false;

    public static void setAntiGiftEvent(boolean antiGiftEvent) {
        AntiGiftEvent = antiGiftEvent;
    }

    public static boolean isAntiGiftEvent() {
        return AntiGiftEvent;
    }

    public static void ClearWorldEntity(){
        for (Entity entity : Main.gameData.getWorld().getEntities()) {
            if(!(entity instanceof Player)){
                if(Main.configYml.isGameSettings("pigkills")) {
                    if(!(entity instanceof Pig)){
                        entity.remove();
                    }
                }else {
                    entity.remove();
                }
                continue;
            }
        }
    }

    public static void loadSchematics(String fileName) {
        int minerY = 3;
        File schema_file = new File("plugins/FastAsyncWorldEdit/schematics",fileName+".schem");
        Location location = new Location(Main.gameData.getWorld(),87.5,minerY,-1.5);
        World world = location.getWorld();
        EditSession editSession = WorldEdit.getInstance().newEditSession(BukkitAdapter.adapt(world));
        Bukkit.getScheduler().runTaskAsynchronously (Main.plugin, () -> {
                    try {
                        Clipboard clipboard = ClipboardFormats.findByFile(schema_file).load(schema_file);
                        clipboard.paste(BukkitAdapter.adapt(world), BlockVector3.at(location.getBlockX(), location.getBlockY(), location.getBlockZ()));
                        clipboard.flush();
                    } catch (Exception e) {
                        e.printStackTrace();
                    } finally {
                        editSession.close();
                    }
                }
        );
    }

    public static void refreshPlayerHandStack(Player p){
        Material material = Material.IRON_BLOCK;
        int rand = RandomUtil.getRandomInt(1,100);
        if(rand >= 75){
            material = Material.GOLD_BLOCK;
        }else if(rand >= 50){
            material = Material.DIAMOND_BLOCK;
        }else if(rand >= 25){
            material = Material.EMERALD_BLOCK;
        }
        Inventory inv = p.getInventory();
        for (int i = 0; i < 9;i++){
            ItemStack item = inv.getItem(i);
            if(item != null && item.getType() != Material.AIR){
                if(item.getType().name().contains("_BLOCK")){
                    inv.setItem(i, new ItemStack(Material.AIR));
                    inv.setItem(i, new ItemStack(material));
                }
            }else {
                inv.setItem(i, new ItemStack(Material.AIR));
                inv.setItem(i, new ItemStack(material));
            }
        }
    }

    public static String HideName(String audience){
        if(audience.length() <= 2){
            return "**";
        }
        // 获取第一个和第二个字符
        char firstChar = audience.charAt(0);
        char lastChar = audience.charAt(audience.length() - 1);
        // 构建屏蔽后的字符串
        StringBuilder maskedString = new StringBuilder();
        for (int i = 1; i < audience.length() - 1; i++) {
            maskedString.append('*');
        }
        return String.valueOf(firstChar) + maskedString + lastChar;
    }

    public static void SendMessage(CommandSender sender, String message){
        sender.sendMessage("§c[系统]§a"+message);
    }
    public static void SendAllSounds(String sound){
        for (Player player : Bukkit.getOnlinePlayers()) {
            if (sound.contains("_")) {
                player.playSound(player.getLocation(), Sound.valueOf(sound), 1, 1);
            } else {
                player.playSound(player.getLocation(), sound, 0.5F, 1);
            }
        }
    }


    public static boolean specialGiftEffectTriggers(Player player,String eventName,String show_userName,int amount){
        if (eventName.contains("盲盒")) {
            if(eventName.contains("#")) {
                String s1 = "love";
                String s2 = "000304";
                String box = s1+"-"+s2+"-"+eventName.split("#")[1];
                if(eventName.contains("X")){
                    amount = Integer.parseInt(eventName.split("X")[1]);
                }
                RBoxAPI.addUserData(player, show_userName, box, amount);
            }else{
                System.out.println("[错误 - 盲盒] 随机盲盒在礼物设置中配置错误.");
            }
            return true;
        }else if (eventName.contains("扩建")) {
            if(eventName.contains("X")){
                amount = Integer.parseInt(eventName.split("X")[1]);
            }
            ExtendAPI.addUserData(show_userName,"向前扩建",amount);
            return true;
        } else if (eventName.contains("拆迁")) {
            if(eventName.contains("X")){
                amount = Integer.parseInt(eventName.split("X")[1]);
            }
            ExtendAPI.addUserData(show_userName,"向前拆除",amount);
            return true;
        } else if (eventName.contains("加宽")) {
            if(eventName.contains("X")){
                amount = Integer.parseInt(eventName.split("X")[1]);
            }
            ExtendAPI.addUserData(show_userName,"向右扩建",amount);
            return true;
        } else if (eventName.contains("变窄")) {
            if(eventName.contains("X")){
                amount = Integer.parseInt(eventName.split("X")[1]);
            }
            ExtendAPI.addUserData(show_userName,"向右拆除",amount);
            return true;
        } else if (eventName.contains("增高")) {
            if(eventName.contains("X")){
                amount = Integer.parseInt(eventName.split("X")[1]);
            }
            ExtendAPI.addUserData(show_userName,"向上扩建",amount);
            return true;
        } else if (eventName.contains("降低")) {
            if(eventName.contains("X")){
                amount = Integer.parseInt(eventName.split("X")[1]);
            }
            ExtendAPI.addUserData(show_userName, "向上拆除", amount);
            return true;
        }else if (eventName.contains("扩圈")) {
            if(eventName.contains("X")){
                amount = Integer.parseInt(eventName.split("X")[1]);
            }
            ExtendAPI.addUserData(show_userName,"扩圈",amount);
            return true;
        } else if (eventName.contains("缩圈")) {
            if(eventName.contains("X")){
                amount = Integer.parseInt(eventName.split("X")[1]);
            }
            ExtendAPI.addUserData(show_userName, "缩圈", amount);
            return true;
        }
        return false;
    }
}
