package me.Demon.BlockWars.api;

import com.sk89q.worldedit.EditSession;
import com.sk89q.worldedit.WorldEdit;
import com.sk89q.worldedit.bukkit.BukkitAdapter;
import com.sk89q.worldedit.function.operation.Operations;
import com.sk89q.worldedit.math.BlockVector3;
import com.sk89q.worldedit.regions.CuboidRegion;
import me.Demon.BlockWars.Game.Point;
import me.Demon.BlockWars.Game.Region;
import me.Demon.BlockWars.Manager.MinerOperate;
import org.bukkit.Bukkit;
import org.bukkit.Material;

public class ExtendEffectAPI {

    public static void rightExpand() {
        Point minPoint = BlockWarsAPI.getGameData().getRegion().getMin();
        Point maxPoint = BlockWarsAPI.getGameData().getRegion().getMax();
        Point newMaxPoint = new Point(maxPoint.getX(), maxPoint.getY(), maxPoint.getZ() + 1);
        Region newRegion = new Region(BlockWarsAPI.getGameData().getRegion().getWorld(), minPoint, newMaxPoint);
        com.sk89q.worldedit.world.World weWorld = BukkitAdapter.adapt(BlockWarsAPI.getGameData().getRegion().getWorld());
        com.yaohun.bwaddon.Main.executorService.submit(() -> {
            BlockVector3 vector1 = BlockVector3.at(minPoint.getX() - 1, minPoint.getY() - 1, maxPoint.getZ() + 2);
            BlockVector3 vector2 = BlockVector3.at(maxPoint.getX() + 1, maxPoint.getY(), maxPoint.getZ() + 2);
            CuboidRegion cuboidRegion = new CuboidRegion(weWorld, vector1, vector2);
            try (EditSession editSession = WorldEdit.getInstance().newEditSession(BukkitAdapter.adapt(BlockWarsAPI.getGameData().getRegion().getWorld()))) {
                editSession.setBlocks((com.sk89q.worldedit.regions.Region) cuboidRegion, BukkitAdapter.asBlockType(Material.WHITE_STAINED_GLASS));
                Operations.complete(editSession.commit());
            } catch (Exception e) {
            }
            BlockVector3 vector3 = BlockVector3.at(minPoint.getX(), minPoint.getY(), maxPoint.getZ() + 1);
            BlockVector3 vector4 = BlockVector3.at(maxPoint.getX(), maxPoint.getY(), maxPoint.getZ() + 2);
            CuboidRegion cuboidRegion1 = new CuboidRegion(weWorld, vector3, vector4);
            try (EditSession editSession = WorldEdit.getInstance().newEditSession(BukkitAdapter.adapt(BlockWarsAPI.getGameData().getRegion().getWorld()))) {
                editSession.setBlocks((com.sk89q.worldedit.regions.Region) cuboidRegion1, BukkitAdapter.asBlockType(Material.AIR));
                Operations.complete(editSession.commit());
            } catch (Exception e) {
            }
        });
        BlockWarsAPI.getGameData().setRegion(newRegion);
    }
    /*
     * 向右拆除
     * */
    public static void rightDisassemble() {
        Point minPoint = BlockWarsAPI.getGameData().getRegion().getMin();
        Point maxPoint = BlockWarsAPI.getGameData().getRegion().getMax();
        if(maxPoint.getZ() < -5){
            Bukkit.broadcastMessage("§c[消息]§a已经是最窄了!");
            return;
        }
        Point newMaxPoint = new Point(maxPoint.getX(), maxPoint.getY(), maxPoint.getZ() - 1);
        Region newRegion = new Region(BlockWarsAPI.getGameData().getRegion().getWorld(), minPoint, newMaxPoint);
        com.sk89q.worldedit.world.World weWorld = BukkitAdapter.adapt(BlockWarsAPI.getGameData().getRegion().getWorld());
        BlockVector3 vector1 = BlockVector3.at(minPoint.getX() - 1, minPoint.getY() - 1, maxPoint.getZ() + 1);
        BlockVector3 vector2 = BlockVector3.at(maxPoint.getX() + 1, maxPoint.getY(), maxPoint.getZ() + 1);
        com.yaohun.bwaddon.Main.executorService.submit(() -> {
        CuboidRegion cuboidRegion = new CuboidRegion(weWorld, vector1, vector2);
        try (EditSession editSession = WorldEdit.getInstance().newEditSession(BukkitAdapter.adapt(BlockWarsAPI.getGameData().getRegion().getWorld()))) {
            editSession.setBlocks((com.sk89q.worldedit.regions.Region) cuboidRegion, BukkitAdapter.asBlockType(Material.AIR));
            Operations.complete(editSession.commit());
        } catch (Exception e) {
        }
        });
        BlockWarsAPI.getGameData().setRegion(newRegion);
    }

    public static void beforeExpand() {
        Point minPoint = BlockWarsAPI.getGameData().getRegion().getMin();
        Point maxPoint = BlockWarsAPI.getGameData().getRegion().getMax();
        Point newMaxPoint = new Point(maxPoint.getX() + 1, maxPoint.getY(), maxPoint.getZ());
        Region newRegion = new Region(BlockWarsAPI.getGameData().getRegion().getWorld(), minPoint, newMaxPoint);
        com.sk89q.worldedit.world.World weWorld = BukkitAdapter.adapt(BlockWarsAPI.getGameData().getRegion().getWorld());
        com.yaohun.bwaddon.Main.executorService.submit(() -> {
            BlockVector3 vector1 = BlockVector3.at(maxPoint.getX() + 2, minPoint.getY() - 1, minPoint.getZ() - 1);
            BlockVector3 vector2 = BlockVector3.at(maxPoint.getX() + 2, maxPoint.getY(), maxPoint.getZ() + 1);
            CuboidRegion cuboidRegion = new CuboidRegion(weWorld, vector1, vector2);
            try (EditSession editSession = WorldEdit.getInstance().newEditSession(BukkitAdapter.adapt(BlockWarsAPI.getGameData().getRegion().getWorld()))) {
                editSession.setBlocks((com.sk89q.worldedit.regions.Region) cuboidRegion, BukkitAdapter.asBlockType(Material.WHITE_STAINED_GLASS));
                Operations.complete(editSession.commit());
            } catch (Exception e) {
            }
            BlockVector3 vector3 = BlockVector3.at(maxPoint.getX() + 1, minPoint.getY(), minPoint.getZ());
            BlockVector3 vector4 = BlockVector3.at(maxPoint.getX() + 2, maxPoint.getY(), maxPoint.getZ());
            CuboidRegion cuboidRegion1 = new CuboidRegion(weWorld, vector3, vector4);
            try (EditSession editSession = WorldEdit.getInstance().newEditSession(BukkitAdapter.adapt(BlockWarsAPI.getGameData().getRegion().getWorld()))) {
                editSession.setBlocks((com.sk89q.worldedit.regions.Region) cuboidRegion1, BukkitAdapter.asBlockType(Material.AIR));
                Operations.complete(editSession.commit());
            } catch (Exception e) {
            }
        });
        BlockWarsAPI.getGameData().setRegion(newRegion);
    }

    /*
     * 向右拆除
     * */
    public static void beforeDisassemble() {
        Point minPoint = BlockWarsAPI.getGameData().getRegion().getMin();
        Point maxPoint = BlockWarsAPI.getGameData().getRegion().getMax();
        if (maxPoint.getX() <= 103){
            Bukkit.broadcastMessage("§c[消息]§a已经是最小了!");
            return;
        }
        Point newMaxPoint = new Point(maxPoint.getX() - 1, maxPoint.getY(), maxPoint.getZ());
        Region newRegion = new Region(BlockWarsAPI.getGameData().getRegion().getWorld(), minPoint, newMaxPoint);
        com.sk89q.worldedit.world.World weWorld = BukkitAdapter.adapt(BlockWarsAPI.getGameData().getRegion().getWorld());
        BlockVector3 vector1 = BlockVector3.at(maxPoint.getX() + 1, minPoint.getY() - 1, minPoint.getZ() - 1);
        BlockVector3 vector2 = BlockVector3.at(maxPoint.getX() + 1, maxPoint.getY(), maxPoint.getZ() + 1);

        com.yaohun.bwaddon.Main.executorService.submit(() -> {
            CuboidRegion cuboidRegion = new CuboidRegion(weWorld, vector1, vector2);
            try (EditSession editSession = WorldEdit.getInstance().newEditSession(BukkitAdapter.adapt(BlockWarsAPI.getGameData().getRegion().getWorld()))) {
                editSession.setBlocks((com.sk89q.worldedit.regions.Region) cuboidRegion, BukkitAdapter.asBlockType(Material.AIR));
                Operations.complete(editSession.commit());
            } catch (Exception e) {
            }
        });
        BlockWarsAPI.getGameData().setRegion(newRegion);
    }

    public static void circleExpand() { // 扩建一圈
        Region region = BlockWarsAPI.getGameData().getRegion(); // 获取当前区域大小
        Point minPoint = region.getMin();
        Point maxPoint = region.getMax();
        Point newMaxPoint = new Point(maxPoint.getX() + 1, maxPoint.getY(), maxPoint.getZ() + 1);
        Region newRegion = new Region(region.getWorld(), minPoint, newMaxPoint);
        com.sk89q.worldedit.world.World weWorld = BukkitAdapter.adapt(region.getWorld());
        BlockVector3 vector1 = BlockVector3.at(maxPoint.getX() + 1, minPoint.getY(), minPoint.getZ());
        BlockVector3 vector2 = BlockVector3.at(maxPoint.getX() + 1, maxPoint.getY(), maxPoint.getZ() + 1);
        CuboidRegion cuboidRegion = new CuboidRegion(weWorld, vector1, vector2);
        BlockVector3 vector3 = BlockVector3.at(maxPoint.getX(), minPoint.getY(), maxPoint.getZ() + 1);
        BlockVector3 vector4 = BlockVector3.at(minPoint.getX(), maxPoint.getY(), maxPoint.getZ() + 1);
        CuboidRegion cuboidRegion1 = new CuboidRegion(weWorld, vector3, vector4);
        BlockVector3 vector5 = BlockVector3.at(maxPoint.getX() + 2, minPoint.getY() - 1, minPoint.getZ() - 1);
        BlockVector3 vector6 = BlockVector3.at(maxPoint.getX() + 2, maxPoint.getY(), maxPoint.getZ() + 2);
        CuboidRegion cuboidRegion2 = new CuboidRegion(weWorld, vector5, vector6);
        BlockVector3 vector9 = BlockVector3.at(maxPoint.getX() + 1, maxPoint.getY(), maxPoint.getZ() + 2);
        BlockVector3 vector10 = BlockVector3.at(minPoint.getX() - 1, minPoint.getY() - 1, maxPoint.getZ() + 2);
        com.yaohun.bwaddon.Main.executorService.submit(() -> {
                    CuboidRegion cuboidRegion3 = new CuboidRegion(weWorld, vector9, vector10);
                    try (EditSession editSession = WorldEdit.getInstance().newEditSession(BukkitAdapter.adapt(region.getWorld()))) {
                        editSession.setBlocks((com.sk89q.worldedit.regions.Region) cuboidRegion, BukkitAdapter.asBlockType(Material.AIR));
                        Operations.complete(editSession.commit());
                    } catch (Exception ignored) {
                    }
                    try (EditSession editSession = WorldEdit.getInstance().newEditSession(BukkitAdapter.adapt(region.getWorld()))) {
                        editSession.setBlocks((com.sk89q.worldedit.regions.Region) cuboidRegion1, BukkitAdapter.asBlockType(Material.AIR));
                        Operations.complete(editSession.commit());
                    } catch (Exception ignored) {
                    }
                    try (EditSession editSession = WorldEdit.getInstance().newEditSession(BukkitAdapter.adapt(region.getWorld()))) {
                        editSession.setBlocks((com.sk89q.worldedit.regions.Region) cuboidRegion2, BukkitAdapter.asBlockType(Material.WHITE_STAINED_GLASS));
                        Operations.complete(editSession.commit());
                    } catch (Exception ignored) {
                    }
                    try (EditSession editSession = WorldEdit.getInstance().newEditSession(BukkitAdapter.adapt(region.getWorld()))) {
                        editSession.setBlocks((com.sk89q.worldedit.regions.Region) cuboidRegion3, BukkitAdapter.asBlockType(Material.WHITE_STAINED_GLASS));
                        Operations.complete(editSession.commit());
                    } catch (Exception ignored) {
                    }
                });
        BlockWarsAPI.getGameData().setRegion(newRegion);
    }

    public static void circleDisassemble() { // 缩小一圈
        Region region = BlockWarsAPI.getGameData().getRegion(); // 获取当前区域大小
        Point minPoint = region.getMin();
        Point maxPoint = region.getMax();
        if(maxPoint.getX() <= 133){return;}
        Point newMaxPoint = new Point(maxPoint.getX() - 1, maxPoint.getY(), maxPoint.getZ() - 1);
        Region newRegion = new Region(region.getWorld(), minPoint, newMaxPoint);
        com.sk89q.worldedit.world.World weWorld = BukkitAdapter.adapt(region.getWorld());
        BlockVector3 vector1 = BlockVector3.at(maxPoint.getX() + 1, minPoint.getY() - 1, minPoint.getZ() - 1);
        BlockVector3 vector2 = BlockVector3.at(maxPoint.getX() + 1, maxPoint.getY(), maxPoint.getZ() + 1);
        CuboidRegion cuboidRegion0 = new CuboidRegion(weWorld, vector1, vector2);
        BlockVector3 vector3 = BlockVector3.at(maxPoint.getX(), maxPoint.getY(), maxPoint.getZ() + 1);
        BlockVector3 vector4 = BlockVector3.at(minPoint.getX() - 1, minPoint.getY() - 1, maxPoint.getZ() + 1);
        CuboidRegion cuboidRegion1 = new CuboidRegion(weWorld, vector3, vector4);
        BlockVector3 vector5 = BlockVector3.at(maxPoint.getX(), minPoint.getY(), minPoint.getZ());
        BlockVector3 vector6 = BlockVector3.at(maxPoint.getX(), maxPoint.getY(), maxPoint.getZ());
        CuboidRegion cuboidRegion2 = new CuboidRegion(weWorld, vector5, vector6);
        BlockVector3 vector7 = BlockVector3.at(maxPoint.getX() - 1, minPoint.getY(), maxPoint.getZ());
        BlockVector3 vector8 = BlockVector3.at(minPoint.getX(), maxPoint.getY(), maxPoint.getZ());
        com.yaohun.bwaddon.Main.executorService.submit(() -> {
                    CuboidRegion cuboidRegion3 = new CuboidRegion(weWorld, vector7, vector8);
                    try (EditSession editSession = WorldEdit.getInstance().newEditSession(BukkitAdapter.adapt(region.getWorld()))) {
                        editSession.setBlocks((com.sk89q.worldedit.regions.Region) cuboidRegion0, BukkitAdapter.asBlockType(Material.AIR));
                        Operations.complete(editSession.commit());
                    } catch (Exception e) {
                    }
                    try (EditSession editSession = WorldEdit.getInstance().newEditSession(BukkitAdapter.adapt(region.getWorld()))) {
                        editSession.setBlocks((com.sk89q.worldedit.regions.Region) cuboidRegion1, BukkitAdapter.asBlockType(Material.AIR));
                        Operations.complete(editSession.commit());
                    } catch (Exception e) {
                    }
                    try (EditSession editSession = WorldEdit.getInstance().newEditSession(BukkitAdapter.adapt(region.getWorld()))) {
                        editSession.setBlocks((com.sk89q.worldedit.regions.Region) cuboidRegion2, BukkitAdapter.asBlockType(Material.WHITE_STAINED_GLASS));
                        Operations.complete(editSession.commit());
                    } catch (Exception e) {
                    }
                    try (EditSession editSession = WorldEdit.getInstance().newEditSession(BukkitAdapter.adapt(region.getWorld()))) {
                        editSession.setBlocks((com.sk89q.worldedit.regions.Region) cuboidRegion3, BukkitAdapter.asBlockType(Material.WHITE_STAINED_GLASS));
                        Operations.complete(editSession.commit());
                    } catch (Exception e) {
                    }
                });
        BlockWarsAPI.getGameData().setRegion(newRegion);
    }

    public static void upExpand(){
        Region region = BlockWarsAPI.getGameData().getRegion(); // 获取当前区域大小
        Point minPoint = region.getMin(); // 获取当前区域的point_A
        Point maxPoint = region.getMax(); // 获取当前区域的point_B
        if(maxPoint.getY() >= 2000){
            Bukkit.broadcastMessage("§c[消息]§a已经最大了,不能再提升高度啦！");
            return;
        }
        BlockVector3 vector1 = BlockVector3.at(minPoint.getX()-1, maxPoint.getY()+1, minPoint.getZ()-1);
        BlockVector3 vector2 = BlockVector3.at(maxPoint.getX()+1, maxPoint.getY(),  maxPoint.getZ()+1);
        com.yaohun.bwaddon.Main.executorService.submit(() -> {
                    CuboidRegion cuboidRegion = new CuboidRegion(BukkitAdapter.adapt(region.getWorld()), vector1, vector2);
                    try (EditSession editSession = WorldEdit.getInstance().newEditSession(BukkitAdapter.adapt(region.getWorld()))) {
                        editSession.makeCuboidWalls(cuboidRegion, BukkitAdapter.asBlockType(Material.WHITE_STAINED_GLASS)); // 设置当前框的为AIR
                    } catch (Exception e) {
                        e.printStackTrace();
                    }
                });
        region.setMax(new Point(maxPoint.getX(), maxPoint.getY()+1, maxPoint.getZ()));
        BlockWarsAPI.getGameData().setRegion(region);
    }

    public static void upDisassemble(){
        Region region = BlockWarsAPI.getGameData().getRegion(); // 获取当前区域大小
        Point minPoint = region.getMin(); // 获取当前区域的point_A
        Point maxPoint = region.getMax(); // 获取当前区域的point_B
        if(maxPoint.getY() <= 10){
            Bukkit.broadcastMessage("§c[消息]§a已经最小了,不能再减少层数啦！");
            return;
        }
        BlockVector3 vector1 = BlockVector3.at(minPoint.getX()-1, maxPoint.getY(), minPoint.getZ()-1);
        BlockVector3 vector2 = BlockVector3.at(maxPoint.getX()+1, maxPoint.getY()+2,  maxPoint.getZ()+1);
        com.yaohun.bwaddon.Main.executorService.submit(() -> {
                    CuboidRegion cuboidRegion = new CuboidRegion(BukkitAdapter.adapt(region.getWorld()), vector1, vector2);
                    try (EditSession editSession = WorldEdit.getInstance().newEditSession(BukkitAdapter.adapt(region.getWorld()))) {
                        editSession.setBlocks((com.sk89q.worldedit.regions.Region) cuboidRegion, BukkitAdapter.asBlockType(Material.AIR)); // 设置当前框的为AIR
                    } catch (Exception e) {
                        e.printStackTrace();
                    }
                });
        region.setMax(new Point(maxPoint.getX(), maxPoint.getY()-1, maxPoint.getZ()));
        BlockWarsAPI.getGameData().setRegion(region);
    }

    /*
    * 设置矿区的围墙
    * */
    public static void setMinerWalls(){
        com.yaohun.bwaddon.Main.executorService.submit(() -> {
            long startTime = System.currentTimeMillis(); // 记录开始时间
            Point minPoint = BlockWarsAPI.getGameRegion().getMin(); // 获取当前区域的point_A
            Point maxPoint = BlockWarsAPI.getGameRegion().getMax(); // 获取当前区域的point_B
            BlockVector3 vector1 = BlockVector3.at(minPoint.getX()-1, minPoint.getY(), minPoint.getZ()-1);
            BlockVector3 vector2 = BlockVector3.at(maxPoint.getX()+1, maxPoint.getY(),  maxPoint.getZ()+1);
            CuboidRegion cuboidRegion = new CuboidRegion(BukkitAdapter.adapt(BlockWarsAPI.getGameRegion().getWorld()),vector1,vector2);
            try (EditSession editSession = WorldEdit.getInstance().newEditSession(BukkitAdapter.adapt(BlockWarsAPI.getGameRegion().getWorld()))) {
                editSession.makeCuboidWalls((com.sk89q.worldedit.regions.Region)cuboidRegion, BukkitAdapter.asBlockType(Material.WHITE_STAINED_GLASS)); // 设置当前框的为AIR
            } catch (Exception e) {
                e.printStackTrace();
            }
            long endTime = System.currentTimeMillis(); // 记录结束时间
            long duration = endTime - startTime; // 计算耗时
        });
    }
    /*
    * 重置矿区大小
    * */
    public static void resetMinerSize() {
        com.yaohun.bwaddon.Main.executorService.submit(() -> {
            Point minPoint = BlockWarsAPI.getGameRegion().getMin(); // 获取当前区域的point_A
            Point maxPoint = BlockWarsAPI.getGameRegion().getMax(); // 获取当前区域的point_B
            BlockVector3 vector1 = BlockVector3.at(minPoint.getX()-1, minPoint.getY()-1, minPoint.getZ()-1);
            BlockVector3 vector2 = BlockVector3.at(maxPoint.getX()+1, maxPoint.getY()+1,  maxPoint.getZ()+1);
            CuboidRegion cuboidRegion = new CuboidRegion(BukkitAdapter.adapt(BlockWarsAPI.getGameRegion().getWorld()),vector1,vector2);
            try (EditSession editSession = WorldEdit.getInstance().newEditSession(BukkitAdapter.adapt(BlockWarsAPI.getGameRegion().getWorld()))) {
                editSession.setBlocks((com.sk89q.worldedit.regions.Region)cuboidRegion, BukkitAdapter.asBlockType(Material.AIR)); // 设置当前框的为AIR
            } catch (Exception e) {
                e.printStackTrace();
            }
        });
    }
}
